Subject: [PATCH 03/15] arm64: Introduce helpers for page table levels

From: [email-masked] (Suzuki K. Poulose)
Date: Fri, 9 Oct 2015 10:22:23 +0100

On 08/10/15 18:28, Catalin Marinas wrote:
> On Thu, Oct 08, 2015 at 06:22:34PM +0100, Suzuki K. Poulose wrote:
>> On 08/10/15 15:45, Christoffer Dall wrote:
>>> On Wed, Oct 07, 2015 at 10:26:14AM +0100, Marc Zyngier wrote:
>>>> I just had a chat with Catalin, who did shed some light on this.
>>>> It all has to do with rounding up. What you would like to have here is:
>>>>
>>>> #define ARM64_HW_PGTABLE_LEVELS(va_bits) DIV_ROUND_UP(va_bits - PAGE_SHIFT, PAGE_SHIFT - 3)
>>>>
>>>> where (va_bits - PAGE_SHIFT) is the total number of bits we deal
>>>> with during a page table walk, and (PAGE_SHIFT - 3) is the number
>>>> of bits we deal with per level.
>>>>
>>>> The clue is in how DIV_ROUND_UP is written:
>>>>
>>>> #define DIV_ROUND_UP(n,d) (((n) + (d) - 1) / (d))
>>>>
>>>> which gives you Suzuki's magic formula.
>>>>
>>>> I'd vote for the DIV_ROUND_UP(), which will make things a lot more readable.
>>>>
>>> Thanks for the explanation, I vote for DIV_ROUND_UP too.
>>
>> Btw, DIV_ROUND_UP is defined in linux/kernel.h, including which in the required
>> headers breaks the build. I could add the definition of the same locally.
>
> Or just keep the original magic formula and add the DIV_ROUND_UP one in
> a comment.
>

OK, will keep proper documentation with the cryptic formula ;)

Suzuki